/* ARCADEmini assembler (windows)
 * version 1.6.1 date 2005-10-19
 * part of the ARCADEmini project - http[s]://arcademini.schuermans.info/
 * Copyright (C) 2003-2005 1stein <1stein@schuermans.info>
 * Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html
 */

#include <stdio.h>

#include "textout.h"

//list with command names and parameters
struct t_textout_cmd
{
  unsigned char len; //length of command
  char * name; //text representation of command
  char * params; //string specifying the parameters to output
} textout_cmds[0x100] =
{
  /* 0x00 */ { 1, "JMP_NEXT_SEC", "" },
  /* 0x01 */ { 5, "JMP_SEC", "S" },
  /* 0x02 */ { 2, "JMP_OFS", "O" },
  /* 0x03 */ { 2, "JMP_OFS", "O" },
  /* 0x04 */ { 6, "JMP_OFS_SEC", "OS" },
  /* 0x05 */ { 6, "JMP_OFS_SEC", "OS" },
  /* 0x06 */ { 7, "JMP_IND", "rrrrrr" },
  /* 0x07 */ { 0, "", "" },
  /* 0x08 */ { 4, "JMP_EQ", "Orr" },
  /* 0x09 */ { 4, "JMP_EQ", "Orr" },
  /* 0x0A */ { 4, "JMP_EQ_C", "Orc" },
  /* 0x0B */ { 4, "JMP_EQ_C", "Orc" },
  /* 0x0C */ { 4, "JMP_NEQ", "Orr" },
  /* 0x0D */ { 4, "JMP_NEQ", "Orr" },
  /* 0x0E */ { 4, "JMP_NEQ_C", "Orc" },
  /* 0x0F */ { 4, "JMP_NEQ_C", "Orc" },
  /* 0x10 */ { 4, "JMP_GT", "Orr" },
  /* 0x11 */ { 4, "JMP_GT", "Orr" },
  /* 0x12 */ { 4, "JMP_GT_C", "Orc" },
  /* 0x13 */ { 4, "JMP_GT_C", "Orc" },
  /* 0x14 */ { 4, "JMP_NGT", "Orr" },
  /* 0x15 */ { 4, "JMP_NGT", "Orr" },
  /* 0x16 */ { 4, "JMP_NGT_C", "Orc" },
  /* 0x17 */ { 4, "JMP_NGT_C", "Orc" },
  /* 0x18 */ { 4, "JMP_LT", "Orr" },
  /* 0x19 */ { 4, "JMP_LT", "Orr" },
  /* 0x1A */ { 4, "JMP_LT_C", "Orc" },
  /* 0x1B */ { 4, "JMP_LT_C", "Orc" },
  /* 0x1C */ { 4, "JMP_NLT", "Orr" },
  /* 0x1D */ { 4, "JMP_NLT", "Orr" },
  /* 0x1E */ { 4, "JMP_NLT_C", "Orc" },
  /* 0x1F */ { 4, "JMP_NLT_C", "Orc" },
  /* 0x20 */ { 4, "JMP_GTS", "Orr" },
  /* 0x22 */ { 4, "JMP_GTS", "Orr" },
  /* 0x22 */ { 4, "JMP_GTS_C", "Orc" },
  /* 0x23 */ { 4, "JMP_GTS_C", "Orc" },
  /* 0x24 */ { 4, "JMP_NGTS", "Orr" },
  /* 0x25 */ { 4, "JMP_NGTS", "Orr" },
  /* 0x26 */ { 4, "JMP_NGTS_C", "Orc" },
  /* 0x27 */ { 4, "JMP_NGTS_C", "Orc" },
  /* 0x28 */ { 4, "JMP_LTS", "Orr" },
  /* 0x29 */ { 4, "JMP_LTS", "Orr" },
  /* 0x2A */ { 4, "JMP_LTS_C", "Orc" },
  /* 0x2B */ { 4, "JMP_LTS_C", "Orc" },
  /* 0x2C */ { 4, "JMP_NLTS", "Orr" },
  /* 0x2D */ { 4, "JMP_NLTS", "Orr" },
  /* 0x2E */ { 4, "JMP_NLTS_C", "Orc" },
  /* 0x2F */ { 4, "JMP_NLTS_C", "Orc" },
  /* 0x30 */ { 4, "JMP_AND_Z", "Orr" },
  /* 0x31 */ { 4, "JMP_AND_Z", "Orr" },
  /* 0x32 */ { 4, "JMP_AND_Z_C", "Orc" },
  /* 0x33 */ { 4, "JMP_AND_Z_C", "Orc" },
  /* 0x34 */ { 4, "JMP_AND_NZ", "Orr" },
  /* 0x35 */ { 4, "JMP_AND_NZ", "Orr" },
  /* 0x36 */ { 4, "JMP_AND_NZ_C", "Orc" },
  /* 0x37 */ { 4, "JMP_AND_NZ_C", "Orc" },
  /* 0x38 */ { 4, "JMP_OR_M", "Orr" },
  /* 0x39 */ { 4, "JMP_OR_M", "Orr" },
  /* 0x3A */ { 4, "JMP_OR_M_C", "Orc" },
  /* 0x3B */ { 4, "JMP_OR_M_C", "Orc" },
  /* 0x3C */ { 4, "JMP_OR_NM", "Orr" },
  /* 0x3D */ { 4, "JMP_OR_NM", "Orr" },
  /* 0x3E */ { 4, "JMP_OR_NM_C", "Orc" },
  /* 0x3F */ { 4, "JMP_OR_NM_C", "Orc" },
  /* 0x40 */ { 0, "", "" },
  /* 0x41 */ { 0, "", "" },
  /* 0x42 */ { 0, "", "" },
  /* 0x43 */ { 0, "", "" },
  /* 0x44 */ { 0, "", "" },
  /* 0x45 */ { 0, "", "" },
  /* 0x46 */ { 0, "", "" },
  /* 0x47 */ { 0, "", "" },
  /* 0x48 */ { 0, "", "" },
  /* 0x49 */ { 0, "", "" },
  /* 0x4A */ { 0, "", "" },
  /* 0x4B */ { 0, "", "" },
  /* 0x4C */ { 0, "", "" },
  /* 0x4D */ { 0, "", "" },
  /* 0x4E */ { 0, "", "" },
  /* 0x4F */ { 0, "", "" },
  /* 0x50 */ { 3, "MOV", "rr" },
  /* 0x51 */ { 3, "MOV_C", "cr" },
  /* 0x52 */ { 5, "MOV2", "rrrr" },
  /* 0x53 */ { 5, "MOV2_C", "crcr" },
  /* 0x54 */ { 9, "MOV4", "rrrrrrrr" },
  /* 0x55 */ { 9, "MOV4_C", "crcrcrcr" },
  /* 0x56 */ { 0, "", "" },
  /* 0x57 */ { 0, "", "" },
  /* 0x58 */ { 3, "RD_I", "rr" },
  /* 0x59 */ { 3, "WR_I", "rr" },
  /* 0x5A */ { 0, "", "" },
  /* 0x5B */ { 0, "", "" },
  /* 0x5C */ { 4, "RD_S", "rrr" },
  /* 0x5D */ { 0, "", "" },
  /* 0x5E */ { 0, "", "" },
  /* 0x5F */ { 0, "", "" },
  /* 0x60 */ { 4, "ADD", "rrr" },
  /* 0x61 */ { 4, "ADD_C", "crr" },
  /* 0x62 */ { 6, "ADDC", "rrrrr" },
  /* 0x63 */ { 6, "ADDC_C", "crrrr" },
  /* 0x64 */ { 4, "SUB", "rrr" },
  /* 0x65 */ { 4, "SUB_C", "crr" },
  /* 0x66 */ { 6, "SUBB", "rrrrr" },
  /* 0x67 */ { 6, "SUBB_C", "crrrr" },
  /* 0x68 */ { 5, "MUL", "rrrr" },
  /* 0x69 */ { 5, "MUL_C", "crrr" },
  /* 0x6A */ { 5, "MULS", "rrrr" },
  /* 0x6B */ { 5, "MULS_C", "crrr" },
  /* 0x6C */ { 6, "DIV", "rrrrr" },
  /* 0x6D */ { 6, "DIVS", "rrrrr" },
  /* 0x6E */ { 0, "", "" },
  /* 0x6F */ { 0, "", "" },
  /* 0x70 */ { 4, "AND", "rrr" },
  /* 0x71 */ { 4, "AND_C", "crr" },
  /* 0x72 */ { 4, "OR", "rrr" },
  /* 0x73 */ { 4, "OR_C", "crr" },
  /* 0x74 */ { 4, "XOR", "rrr" },
  /* 0x75 */ { 4, "XOR", "crr" },
  /* 0x76 */ { 0, "", "" },
  /* 0x77 */ { 0, "", "" },
  /* 0x78 */ { 4, "SHL", "rrr" },
  /* 0x79 */ { 4, "SHL_C", "crr" },
  /* 0x7A */ { 4, "SHR", "rrr" },
  /* 0x7B */ { 4, "SHR_C", "crr" },
  /* 0x7C */ { 4, "ROL", "rrr" },
  /* 0x7D */ { 4, "ROL_C", "crr" },
  /* 0x7E */ { 4, "ROR", "rrr" },
  /* 0x7F */ { 4, "ROR_C", "crr" },
  /* 0x80 */ { 0, "", "" },
  /* 0x81 */ { 0, "", "" },
  /* 0x82 */ { 0, "", "" },
  /* 0x83 */ { 0, "", "" },
  /* 0x84 */ { 0, "", "" },
  /* 0x85 */ { 0, "", "" },
  /* 0x86 */ { 0, "", "" },
  /* 0x87 */ { 0, "", "" },
  /* 0x88 */ { 0, "", "" },
  /* 0x89 */ { 0, "", "" },
  /* 0x8A */ { 0, "", "" },
  /* 0x8B */ { 0, "", "" },
  /* 0x8C */ { 0, "", "" },
  /* 0x8D */ { 0, "", "" },
  /* 0x8E */ { 0, "", "" },
  /* 0x8F */ { 0, "", "" },
  /* 0x90 */ { 4, "RD_PIX", "rrr" },
  /* 0x91 */ { 4, "RD_PIX_C", "ccr" },
  /* 0x92 */ { 4, "RD_OVP", "rrr" },
  /* 0x93 */ { 4, "RD_OVP_C", "ccr" },
  /* 0x94 */ { 4, "WR_PIX", "rrr" },
  /* 0x95 */ { 4, "WR_PIX_C", "ccr" },
  /* 0x96 */ { 4, "WR_OVP", "rrr" },
  /* 0x97 */ { 4, "WR_OVP_C", "ccr" },
  /* 0x98 */ { 4, "WR_PIX_CO", "rrc" },
  /* 0x99 */ { 4, "WR_PIX_CO_C", "ccc" },
  /* 0x9A */ { 4, "WR_OVP_CO", "rrc" },
  /* 0x9B */ { 4, "WR_OVP_CO_C", "ccc" },
  /* 0x9C */ { 0, "", "" },
  /* 0x9D */ { 0, "", "" },
  /* 0x9E */ { 0, "", "" },
  /* 0x9F */ { 0, "", "" },
  /* 0xA0 */ { 15, "WR_PIX_LINE", "r." },
  /* 0xA1 */ { 15, "WR_PIX_LINE_C", "c." },
  /* 0xA2 */ { 15, "WR_OVP_LINE", "r." },
  /* 0xA3 */ { 15, "WR_OVP_LINE_C", "c." },
  /* 0xA4 */ { 67, "WR_PIX_QUART", "r." },
  /* 0xA5 */ { 67, "WR_PIX_QUART_C", "c." },
  /* 0xA6 */ { 67, "WR_OVP_QUART", "r." },
  /* 0xA7 */ { 67, "WR_OVP_QUART_C", "c." },
  /* 0xA8 */ { 1, "WR_PIX_CLR", "" },
  /* 0xA9 */ { 1, "WR_OVP_CLR", "" },
  /* 0xAA */ { 1, "WR_PIX_SET", "" },
  /* 0xAB */ { 1, "WR_OVP_SET", "" },
  /* 0xAC */ { 66, "WR_PIX_BW", "." },
  /* 0xAD */ { 66, "WR_OVP_BW", "." },
  /* 0xAE */ { 67, "WR_PIX_SEL", "r." },
  /* 0xAF */ { 67, "WR_PIX_SEL_C", "c." },
  /* 0xB0 */ { 67, "WR_OVP_SEL", "r." },
  /* 0xB1 */ { 67, "WR_OVP_SEL_C", "c." },
  /* 0xB2 */ { 0, "", "" },
  /* 0xB3 */ { 0, "", "" },
  /* 0xB4 */ { 0, "", "" },
  /* 0xB5 */ { 0, "", "" },
  /* 0xB6 */ { 0, "", "" },
  /* 0xB7 */ { 0, "", "" },
  /* 0xB8 */ { 0, "", "" },
  /* 0xB9 */ { 0, "", "" },
  /* 0xBA */ { 0, "", "" },
  /* 0xBB */ { 0, "", "" },
  /* 0xBC */ { 0, "", "" },
  /* 0xBD */ { 0, "", "" },
  /* 0xBE */ { 0, "", "" },
  /* 0xBF */ { 0, "", "" },
  /* 0xC0 */ { 1, "DISPLAY", "" },
  /* 0xC1 */ { 1, "DISPLAY_CP", "" },
  /* 0xC2 */ { 0, "", "" },
  /* 0xC3 */ { 0, "", "" },
  /* 0xC4 */ { 0, "", "" },
  /* 0xC5 */ { 0, "", "" },
  /* 0xC6 */ { 0, "", "" },
  /* 0xC7 */ { 0, "", "" },
  /* 0xC8 */ { 3, "DELAY_DO", "rr" },
  /* 0xC9 */ { 3, "DELAY_DO_C", "C" },
  /* 0xCA */ { 3, "DELAY_START", "rr" },
  /* 0xCB */ { 3, "DELAY_START_C", "C" },
  /* 0xCC */ { 2, "DELAY_CHECK", "r" },
  /* 0xCD */ { 1, "DELAY_WAIT", "" },
  /* 0xCE */ { 0, "", "" },
  /* 0xCF */ { 0, "", "" },
  /* 0xD0 */ { 4, "GET_KEYS", "rrr" },
  /* 0xD1 */ { 0, "", "" },
  /* 0xD2 */ { 7, "GET_SNES0", "rrrrrr" },
  /* 0xD3 */ { 7, "GET_SNES1", "rrrrrr" },
  /* 0xD4 */ { 4, "GET_TIME", "rrr" },
  /* 0xD5 */ { 4, "SET_TIME", "rrr" },
  /* 0xD6 */ { 0, "", "" },
  /* 0xD7 */ { 0, "", "" },
  /* 0xD8 */ { 0, "", "" },
  /* 0xD9 */ { 0, "", "" },
  /* 0xDA */ { 0, "", "" },
  /* 0xDB */ { 0, "", "" },
  /* 0xDC */ { 0, "", "" },
  /* 0xDD */ { 0, "", "" },
  /* 0xDE */ { 0, "", "" },
  /* 0xDF */ { 0, "", "" },
  /* 0xE0 */ { 0, "", "" },
  /* 0xE1 */ { 0, "", "" },
  /* 0xE2 */ { 0, "", "" },
  /* 0xE3 */ { 0, "", "" },
  /* 0xE4 */ { 0, "", "" },
  /* 0xE5 */ { 0, "", "" },
  /* 0xE6 */ { 0, "", "" },
  /* 0xE7 */ { 0, "", "" },
  /* 0xE8 */ { 0, "", "" },
  /* 0xE9 */ { 0, "", "" },
  /* 0xEA */ { 0, "", "" },
  /* 0xEB */ { 0, "", "" },
  /* 0xEC */ { 0, "", "" },
  /* 0xED */ { 0, "", "" },
  /* 0xEE */ { 0, "", "" },
  /* 0xEF */ { 0, "", "" },
  /* 0xF0 */ { 0, "", "" },
  /* 0xF1 */ { 0, "", "" },
  /* 0xF2 */ { 0, "", "" },
  /* 0xF3 */ { 0, "", "" },
  /* 0xF4 */ { 0, "", "" },
  /* 0xF5 */ { 0, "", "" },
  /* 0xF6 */ { 0, "", "" },
  /* 0xF7 */ { 0, "", "" },
  /* 0xF8 */ { 0, "", "" },
  /* 0xF9 */ { 0, "", "" },
  /* 0xFA */ { 0, "", "" },
  /* 0xFB */ { 0, "", "" },
  /* 0xFC */ { 0, "", "" },
  /* 0xFD */ { 0, "", "" },
  /* 0xFE */ { 0, "", "" },
  /* 0xFF */ { 1, "NOP", "" },
};

//output command in human readable form (internal use)
static void textout_internal( FILE * p_stream, char * name, char * params, unsigned char * p_cmd_data )
{
  int i, pos;

  //no stream
  if( p_stream == NULL )
    return;

  //write command name and parameters
  fprintf( p_stream, "             %s", name );
  pos = 1;
  for( i = 0; params[i] != 0; i++ )
  {
    switch( params[i] )
    {
      case 'i': //ignore a byte
        pos++;
        break;
      case 'c': //8-bit constant
        fprintf( p_stream, " 0x%02X", p_cmd_data[pos] );
        pos++;
        break;
      case 'C': //16-bit constant
        fprintf( p_stream, " 0x%02X%02X", p_cmd_data[pos], p_cmd_data[pos + 1] );
        pos += 2;
        break;
      case 'O': //offset (9-bit)
        fprintf( p_stream, " 0x%X%02X", p_cmd_data[pos - 1] & 0x01, p_cmd_data[pos] );
        pos++;
        break;
      case 'S': //sector or 32-bit constant
        fprintf( p_stream, " 0x%02X%02X%02X%02X", p_cmd_data[pos], p_cmd_data[pos + 1], p_cmd_data[pos + 2], p_cmd_data[pos + 3] );
        pos += 4;
        break;
      case 'r': //register
        fprintf( p_stream, " $0x%02X", p_cmd_data[pos] );
        pos++;
        break;
      case '.': //left out parameters
        fprintf( p_stream, " ..." );
        break;
    }
  }
  fputc( '\n', p_stream );
}

//special behaviour for CP_BLK
void textout_CP_BLK( FILE * p_stream, unsigned char * p_cmd_data )
{
  unsigned char flags = p_cmd_data[1];
  unsigned char params[8] =
  {
    'i',
    flags & 0x20 ? 'c' : 'r',
    flags & 0x10 ? 'c' : 'r',
    flags & 0x08 ? 'c' : 'r',
    flags & 0x04 ? 'c' : 'r',
    flags & 0x02 ? 'c' : 'r',
    flags & 0x01 ? 'c' : 'r',
    0
  };
  if( flags & 0x80 )
    if( flags & 0x40 )
      textout_internal( p_stream, "WR_CP_BLK_OO", params, p_cmd_data );
    else
      textout_internal( p_stream, "WR_CP_BLK_OP", params, p_cmd_data );
  else
    if( flags & 0x40 )
      textout_internal( p_stream, "WR_CP_BLK_PO", params, p_cmd_data );
    else
      textout_internal( p_stream, "WR_CP_BLK_PP", params, p_cmd_data );
}

//special behaviour for CP_BLK_TR
void textout_CP_BLK_TR( FILE * p_stream, unsigned char * p_cmd_data )
{
  unsigned char flags = p_cmd_data[1];
  unsigned char params[9] =
  {
    'i',
    'r',
    flags & 0x20 ? 'c' : 'r',
    flags & 0x10 ? 'c' : 'r',
    flags & 0x08 ? 'c' : 'r',
    flags & 0x04 ? 'c' : 'r',
    flags & 0x02 ? 'c' : 'r',
    flags & 0x01 ? 'c' : 'r',
    0
  };
  if( flags & 0x80 )
    if( flags & 0x40 )
      textout_internal( p_stream, "WR_CP_BLK_OO_TR", params, p_cmd_data );
    else
      textout_internal( p_stream, "WR_CP_BLK_OP_TR", params, p_cmd_data );
  else
    if( flags & 0x40 )
      textout_internal( p_stream, "WR_CP_BLK_PO_TR", params, p_cmd_data );
    else
      textout_internal( p_stream, "WR_CP_BLK_PP_TR", params, p_cmd_data );
}

//special behaviour for CP_BLK_TR_C
void textout_CP_BLK_TR_C( FILE * p_stream, unsigned char * p_cmd_data )
{
  unsigned char flags = p_cmd_data[1];
  unsigned char params[9] =
  {
    'i',
    'c',
    flags & 0x20 ? 'c' : 'r',
    flags & 0x10 ? 'c' : 'r',
    flags & 0x08 ? 'c' : 'r',
    flags & 0x04 ? 'c' : 'r',
    flags & 0x02 ? 'c' : 'r',
    flags & 0x01 ? 'c' : 'r',
    0
  };
  if( flags & 0x80 )
    if( flags & 0x40 )
      textout_internal( p_stream, "WR_CP_BLK_OO_TR_C", params, p_cmd_data );
    else
      textout_internal( p_stream, "WR_CP_BLK_OP_TR_C", params, p_cmd_data );
  else
    if( flags & 0x40 )
      textout_internal( p_stream, "WR_CP_BLK_PO_TR_C", params, p_cmd_data );
    else
      textout_internal( p_stream, "WR_CP_BLK_PP_TR_C", params, p_cmd_data );
}

//output command in human readable form to stream (if possible)
void textout_textout( FILE * p_stream, unsigned char * p_cmd_data, unsigned char cmd_len )
{
  unsigned char cmd;
  struct t_textout_cmd * p_cmd;

  //no command
  if( cmd_len == 0 )
    return;

  //get data of command
  cmd = p_cmd_data[0];
  p_cmd = &textout_cmds[cmd];

  //special command: CP_BLK
  if( cmd_len == 8 && cmd == 0xB4 )
    textout_CP_BLK( p_stream, p_cmd_data );
  //special command: CP_BLK_TR
  else if( cmd_len == 9 && cmd == 0xB6 )
    textout_CP_BLK_TR( p_stream, p_cmd_data );
  //special command: CP_BLK_TR_C
  else if( cmd_len == 9 && cmd == 0xB7 )
    textout_CP_BLK_TR_C( p_stream, p_cmd_data );
  //normal command
  else if( cmd_len == p_cmd->len )
    textout_internal( p_stream, p_cmd->name, p_cmd->params, p_cmd_data );
}

